Package com.meterware.servletunit

# Class ServletUnitServletContext

java.lang.Object
com.meterware.servletunit.ServletUnitServletContext

All Implemented Interfaces:
  `javax.servlet.ServletContext`

public class ServletUnitServletContext extends Object implements javax.servlet.ServletContext
This class is a private implementation of the ServletContext class.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_SERVER_INFO`

### Fields inherited from interface javax.servlet.ServletContext

`ORDERED_LIBS, TEMPDIR`

## Method Summary

Modifier and Type
Method
Description
`javax.servlet.FilterRegistration.Dynamic`
`addFilter(String filterName, Class<? extends javax.servlet.Filter> filterClass)`
`javax.servlet.FilterRegistration.Dynamic`
`addFilter(String filterName, String className)`
`javax.servlet.FilterRegistration.Dynamic`
`addFilter(String filterName, javax.servlet.Filter filter)`
`void`
`addListener(Class<? extends EventListener> listenerClass)`
`void`
`addListener(String className)`
`<T extends EventListener>
void`
`addListener(T t)`
`javax.servlet.ServletRegistration.Dynamic`
`addServlet(String servletName, Class<? extends javax.servlet.Servlet> servletClass)`
`javax.servlet.ServletRegistration.Dynamic`
`addServlet(String servletName, String className)`
`javax.servlet.ServletRegistration.Dynamic`
`addServlet(String servletName, javax.servlet.Servlet servlet)`
`<T extends javax.servlet.Filter>
T`
`createFilter(Class<T> clazz)`
`<T extends EventListener>
T`
`createListener(Class<T> clazz)`
`<T extends javax.servlet.Servlet>
T`
`createServlet(Class<T> clazz)`
`void`
`declareRoles(String... roleNames)`
`Object`
`getAttribute(String name)`
Returns the servlet container attribute with the given name, or null if there is no attribute by that name.
`Enumeration`
`getAttributeNames()`
`ClassLoader`
`getClassLoader()`
`javax.servlet.ServletContext`
`getContext(String A)`
Returns a ServletContext object that corresponds to a specified URL on the server.
`String`
`getContextPath()`
`Set<javax.servlet.SessionTrackingMode>`
`getDefaultSessionTrackingModes()`
`int`
`getEffectiveMajorVersion()`
`int`
`getEffectiveMinorVersion()`
`Set<javax.servlet.SessionTrackingMode>`
`getEffectiveSessionTrackingModes()`
`javax.servlet.FilterRegistration`
`getFilterRegistration(String filterName)`
`Map<String,? extends javax.servlet.FilterRegistration>`
`getFilterRegistrations()`
`String`
`getInitParameter(String name)`
Returns a String containing the value of the named context-wide initialization parameter, or null if the parameter does not exist.
`Enumeration`
`getInitParameterNames()`
Returns the names of the context's initialization parameters as an Enumeration of String objects, or an empty Enumeration if the context has no initialization parameters.
`javax.servlet.descriptor.JspConfigDescriptor`
`getJspConfigDescriptor()`
`int`
`getMajorVersion()`
Returns the major version of the Java Servlet API that this servlet container supports.
`String`
`getMimeType(String filePath)`
Returns the MIME type of the specified file, or null if the MIME type is not known.
`int`
`getMinorVersion()`
Returns the minor version of the Servlet API that this servlet container supports.
`javax.servlet.RequestDispatcher`
`getNamedDispatcher(String A)`
Returns a RequestDispatcher object that acts as a wrapper for the named servlet.
`String`
`getRealPath(String path)`
Returns a String containing the real path for a given virtual path.
`javax.servlet.RequestDispatcher`
`getRequestDispatcher(String path)`
Returns a RequestDispatcher object that acts as a wrapper for the resource located at the given path.
`URL`
`getResource(String path)`
Returns a URL to the resource that is mapped to a specified path.
`InputStream`
`getResourceAsStream(String path)`
Returns the resource located at the named path as an InputStream object.
`Set`
`getResourcePaths(String path)`
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.
`String`
`getServerInfo()`
Returns the name and version of the servlet container on which the servlet is running.
`javax.servlet.Servlet`
`getServlet(String A)`
Deprecated.
as of Servlet API 2.1
`String`
`getServletContextName()`
Returns the name of this web application correponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.
`Enumeration`
`getServletNames()`
Deprecated.
as of Servlet API 2.1
`javax.servlet.ServletRegistration`
`getServletRegistration(String servletName)`
`Map<String,? extends javax.servlet.ServletRegistration>`
`getServletRegistrations()`
`Enumeration`
`getServlets()`
Deprecated.
as of Servlet API 2.0
`javax.servlet.SessionCookieConfig`
`getSessionCookieConfig()`
`String`
`getVirtualServerName()`
`void`
`log(Exception e, String message)`
Deprecated.
use log( String, Throwable )
`void`
`log(String message)`
Writes the specified message to a servlet log file, usually an event log.
`void`
`log(String message, Throwable t)`
Writes an explanatory message and a stack trace for a given Throwable exception to the servlet log file.
`void`
`removeAttribute(String name)`
`void`
`setAttribute(String name, Object attribute)`
`boolean`
`setInitParameter(String name, String value)`
`void`
`setLogStream(PrintStream logStream)`
Allows the test to determine where the log messages should be written.
`void`
`setSessionTrackingModes(Set<javax.servlet.SessionTrackingMode> sessionTrackingModes)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface javax.servlet.ServletContext

`addJspFile, getRequestCharacterEncoding, getResponseCharacterEncoding, getSessionTimeout, setRequestCharacterEncoding, setResponseCharacterEncoding, setSessionTimeout`

## Field Details

### DEFAULT_SERVER_INFO

public static final String DEFAULT_SERVER_INFO

See Also:
  - Constant Field Values

## Method Details

### getContext

public javax.servlet.ServletContext getContext(String A)
Returns a ServletContext object that corresponds to a specified URL on the server.

This method allows servlets to gain access to the context for various parts of the server, and as needed obtain RequestDispatcher objects from the context. The given path must be absolute (beginning with "/") and is interpreted based on the server's document root.

In a security conscious environment, the servlet container may return null for a given URL.

Specified by:
  `getContext` in interface `javax.servlet.ServletContext`

### getMajorVersion

public int getMajorVersion()
Returns the major version of the Java Servlet API that this servlet container supports. All implementations that comply with Version 2.4 must have this method return the integer 2.

Specified by:
  `getMajorVersion` in interface `javax.servlet.ServletContext`

### getMinorVersion

public int getMinorVersion()
Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 2.4 must have this method return the integer 4.

Specified by:
  `getMinorVersion` in interface `javax.servlet.ServletContext`

### getMimeType

public String getMimeType(String filePath)
Returns the MIME type of the specified file, or null if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types are "text/html" and "image/gif".

Specified by:
  `getMimeType` in interface `javax.servlet.ServletContext`

### getResource

public URL getResource(String path)
Returns a URL to the resource that is mapped to a specified path. The path must begin with a "/" and is interpreted as relative to the current context root.

This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a local or remote file system, in a database, or in a .war file.

The servlet container must implement the URL handlers and URLConnection objects that are necessary to access the resource.

This method returns null if no resource is mapped to the pathname. Some containers may allow writing to the URL returned by this method using the methods of the URL class. The resource content is returned directly, so be aware that requesting a .jsp page returns the JSP source code. Use a RequestDispatcher instead to include results of an execution. This method has a different purpose than java.lang.Class.getResource, which looks up resources based on a class loader. This method does not use class loaders.

Specified by:
  `getResource` in interface `javax.servlet.ServletContext`

### getResourceAsStream

public InputStream getResourceAsStream(String path)
Returns the resource located at the named path as an InputStream object. The data in the InputStream can be of any type or length. The path must be specified according to the rules given in getResource. This method returns null if no resource exists at the specified path. Meta-information such as content length and content type that is available via getResource method is lost when using this method. The servlet container must implement the URL handlers and URLConnection objects necessary to access the resource. This method is different from java.lang.Class.getResourceAsStream, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

Specified by:
  `getResourceAsStream` in interface `javax.servlet.ServletContext`

### getRequestDispatcher

public javax.servlet.RequestDispatcher getRequestDispatcher(String path)
Returns a RequestDispatcher object that acts as a wrapper for the resource located at the given path. A RequestDispatcher object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static. The pathname must begin with a "/" and is interpreted as relative to the current context root. Use getContext to obtain a RequestDispatcher for resources in foreign contexts. This method returns null if the ServletContext cannot return a RequestDispatcher.

Specified by:
  `getRequestDispatcher` in interface `javax.servlet.ServletContext`

### getNamedDispatcher

public javax.servlet.RequestDispatcher getNamedDispatcher(String A)
Returns a RequestDispatcher object that acts as a wrapper for the named servlet. Servlets (and JSP pages also) may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using ServletConfig.getServletName(). This method returns null if the ServletContext cannot return a RequestDispatcher for any reason.

Specified by:
  `getNamedDispatcher` in interface `javax.servlet.ServletContext`

### getServlet

public javax.servlet.Servlet getServlet(String A)
Deprecated.
as of Servlet API 2.1

Specified by:
  `getServlet` in interface `javax.servlet.ServletContext`

### getServlets

public Enumeration getServlets()
Deprecated.
as of Servlet API 2.0

Specified by:
  `getServlets` in interface `javax.servlet.ServletContext`

### getServletNames

public Enumeration getServletNames()
Deprecated.
as of Servlet API 2.1

Specified by:
  `getServletNames` in interface `javax.servlet.ServletContext`

### log

public void log(String message)
Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

Specified by:
  `log` in interface `javax.servlet.ServletContext`

### log

public void log(Exception e, String message)
Deprecated.
use log( String, Throwable )

Specified by:
  `log` in interface `javax.servlet.ServletContext`

### log

public void log(String message, Throwable t)
Writes an explanatory message and a stack trace for a given Throwable exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

Specified by:
  `log` in interface `javax.servlet.ServletContext`

### getRealPath

public String getRealPath(String path)
Returns a String containing the real path for a given virtual path. For example, the virtual path "/index.html" has a real path of whatever file on the server's filesystem would be served by a request for "/index.html". The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators. This method returns null if the servlet container cannot translate the virtual path to a real path for any reason (such as when the content is being made available from a .war archive).

Specified by:
  `getRealPath` in interface `javax.servlet.ServletContext`

### getServerInfo

public String getServerInfo()
Returns the name and version of the servlet container on which the servlet is running. The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string JavaServer Web Dev Kit/1.0. The servlet container may return other optional information after the primary string in parentheses, for example, JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86).

Specified by:
  `getServerInfo` in interface `javax.servlet.ServletContext`

### getInitParameter

public String getInitParameter(String name)
Returns a String containing the value of the named context-wide initialization parameter, or null if the parameter does not exist. This method can make available configuration information useful to an entire "web application". For example, it can provide a webmaster's email address or the name of a system that holds critical data.

Specified by:
  `getInitParameter` in interface `javax.servlet.ServletContext`

### getInitParameterNames

public Enumeration getInitParameterNames()
Returns the names of the context's initialization parameters as an Enumeration of String objects, or an empty Enumeration if the context has no initialization parameters.

Specified by:
  `getInitParameterNames` in interface `javax.servlet.ServletContext`

### getAttribute

public Object getAttribute(String name)
Returns the servlet container attribute with the given name, or null if there is no attribute by that name. An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using getAttributeNames.

Specified by:
  `getAttribute` in interface `javax.servlet.ServletContext`

### getAttributeNames

public Enumeration getAttributeNames()

Specified by:
  `getAttributeNames` in interface `javax.servlet.ServletContext`

### setAttribute

public void setAttribute(String name, Object attribute)

Specified by:
  `setAttribute` in interface `javax.servlet.ServletContext`

### removeAttribute

public void removeAttribute(String name)

Specified by:
  `removeAttribute` in interface `javax.servlet.ServletContext`

### getResourcePaths

public Set getResourcePaths(String path)
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument. Paths indicating subdirectory paths end with a '/'. The returned paths are all relative to the root of the web application and have a leading '/'. For example, for a web application containing

/welcome.html
/catalog/index.html
/catalog/products.html
/catalog/offers/books.html
/catalog/offers/music.html
/customer/login.jsp
/WEB-INF/web.xml
/WEB-INF/classes/com.acme.OrderServlet.class,
getResourcePaths("/") returns {"/welcome.html", "/catalog/", "/customer/", "/WEB-INF/"}
getResourcePaths("/catalog/") returns {"/catalog/index.html", "/catalog/products.html", "/catalog/offers/"}.

Specified by:
  `getResourcePaths` in interface `javax.servlet.ServletContext`
Parameters:
  `path` - partial path used to match the resources, which must start with a /
Returns:
  a Set containing the directory listing, or null if there are no resources in the web application whose path begins with the supplied path.
Since:
  HttpUnit 1.3

### getServletContextName

public String getServletContextName()
Returns the name of this web application correponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

Specified by:
  `getServletContextName` in interface `javax.servlet.ServletContext`
Returns:
  The name of the web application or null if no name has been declared in the deployment descriptor
Since:
  HttpUnit 1.3

### getContextPath

public String getContextPath()

Specified by:
  `getContextPath` in interface `javax.servlet.ServletContext`

### getEffectiveMajorVersion

public int getEffectiveMajorVersion()

Specified by:
  `getEffectiveMajorVersion` in interface `javax.servlet.ServletContext`

### getEffectiveMinorVersion

public int getEffectiveMinorVersion()

Specified by:
  `getEffectiveMinorVersion` in interface `javax.servlet.ServletContext`

### setInitParameter

public boolean setInitParameter(String name, String value)

Specified by:
  `setInitParameter` in interface `javax.servlet.ServletContext`

### addServlet

public javax.servlet.ServletRegistration.Dynamic addServlet(String servletName, String className)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

### addServlet

public javax.servlet.ServletRegistration.Dynamic addServlet(String servletName, javax.servlet.Servlet servlet)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

### addServlet

public javax.servlet.ServletRegistration.Dynamic addServlet(String servletName, Class<? extends javax.servlet.Servlet> servletClass)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

### createServlet

public <T extends javax.servlet.Servlet> T createServlet(Class<T> clazz) throws javax.servlet.ServletException

Specified by:
  `createServlet` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

### getServletRegistration

public javax.servlet.ServletRegistration getServletRegistration(String servletName)

Specified by:
  `getServletRegistration` in interface `javax.servlet.ServletContext`

### getServletRegistrations

public Map<String,? extends javax.servlet.ServletRegistration> getServletRegistrations()

Specified by:
  `getServletRegistrations` in interface `javax.servlet.ServletContext`

### addFilter

public javax.servlet.FilterRegistration.Dynamic addFilter(String filterName, String className)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

### addFilter

public javax.servlet.FilterRegistration.Dynamic addFilter(String filterName, javax.servlet.Filter filter)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

### addFilter

public javax.servlet.FilterRegistration.Dynamic addFilter(String filterName, Class<? extends javax.servlet.Filter> filterClass)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

### createFilter

public <T extends javax.servlet.Filter> T createFilter(Class<T> clazz) throws javax.servlet.ServletException

Specified by:
  `createFilter` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

### getFilterRegistration

public javax.servlet.FilterRegistration getFilterRegistration(String filterName)

Specified by:
  `getFilterRegistration` in interface `javax.servlet.ServletContext`

### getFilterRegistrations

public Map<String,? extends javax.servlet.FilterRegistration> getFilterRegistrations()

Specified by:
  `getFilterRegistrations` in interface `javax.servlet.ServletContext`

### getSessionCookieConfig

public javax.servlet.SessionCookieConfig getSessionCookieConfig()

Specified by:
  `getSessionCookieConfig` in interface `javax.servlet.ServletContext`

### setSessionTrackingModes

public void setSessionTrackingModes(Set<javax.servlet.SessionTrackingMode> sessionTrackingModes)

Specified by:
  `setSessionTrackingModes` in interface `javax.servlet.ServletContext`

### getDefaultSessionTrackingModes

public Set<javax.servlet.SessionTrackingMode> getDefaultSessionTrackingModes()

Specified by:
  `getDefaultSessionTrackingModes` in interface `javax.servlet.ServletContext`

### getEffectiveSessionTrackingModes

public Set<javax.servlet.SessionTrackingMode> getEffectiveSessionTrackingModes()

Specified by:
  `getEffectiveSessionTrackingModes` in interface `javax.servlet.ServletContext`

### addListener

public void addListener(String className)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

### addListener

public <T extends EventListener> void addListener(T t)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

### addListener

public void addListener(Class<? extends EventListener> listenerClass)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

### createListener

public <T extends EventListener> T createListener(Class<T> clazz) throws javax.servlet.ServletException

Specified by:
  `createListener` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

### getJspConfigDescriptor

public javax.servlet.descriptor.JspConfigDescriptor getJspConfigDescriptor()

Specified by:
  `getJspConfigDescriptor` in interface `javax.servlet.ServletContext`

### getClassLoader

public ClassLoader getClassLoader()

Specified by:
  `getClassLoader` in interface `javax.servlet.ServletContext`

### declareRoles

public void declareRoles(String... roleNames)

Specified by:
  `declareRoles` in interface `javax.servlet.ServletContext`

### getVirtualServerName

public String getVirtualServerName()

Specified by:
  `getVirtualServerName` in interface `javax.servlet.ServletContext`

### setLogStream

public void setLogStream(PrintStream logStream)
Allows the test to determine where the log messages should be written. Defaults to `System.out`

Parameters:
  `logStream` - where to write the log messages
See Also:
  - `log(String)`